% =========================================================================
%   Praktikum MATLAB/Simulink II
%   Technische Universitt Darmstadt
%   IAT, FG rtm (Prof. Dr.-Ing. U. Konigorski)
%
%   Copyright (c) 2017, FG Regelungstechnik und Mechatronik,
%                       Technische Universitt Darmstadt
%   All rights reserved.
%
%   Redistribution and use in source and binary forms, with or withou
%   modification, are permitted provided that the following conditions are
%   met:
%
%   1. Redistributions of source code must retain the above copyright
%      notice, this list of conditions and the following disclaimer.
%
%   2. Redistributions in binary form must reproduce the above copyright
%      notice, this list of conditions and the following disclaimer in the
%      documentation and/or other materials provided with the distribution.
%
%
%   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
%   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
%   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
%   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
%   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
%   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
%   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
%   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

% =========================================================================

function Aufgabe_SteuerbarkBeobachtbark
    % Untersuchung der Steuer- und Beobachtbarkeit nach verschiedenen
    % Kriterien
	clc;

	para

%	[A,B,C] = initLinear( l, mp, ms, Rs, Rp, g, pi );
%    [A,B,C] = initLinear( l, mp, ms, Rs, 0, g, pi );
    [A,B,C] = initLinear( l, mp, ms, 0, 0, g, pi );
	
    %% Steuer- und Beobachtbarkeit nach Kalman
    checkCtrbKalman( A, B );
%     if ( rank( ctrb( A, B ) ) == size( A, 1 ) )
%         disp( 'Steuerbar nach Kalman!' );
%     else
%         disp( 'Nicht steuerbar nach Kalman!' );
%     end
    
    checkObsvKalman( A, C );
%     if ( rank( obsv( A, C ) ) == size( A, 1 ) )
%         disp( 'Beobachtbar nach Kalman!' );
%     else
%         disp( 'Nicht beobachtbar nach Kalman!' );
%     end
    
    %% Steuer- und Beobachtbarkeit nach Gilbert
    checkCtrbGilbert( A, B );
    checkObsvGilbert( A, C );
    
    %% Steuer- und Beobachtbarkeit nach Hautus
    checkCtrbHautus( A, B );
    checkObsvHautus( A, C );

end